HDU 1087 - Super Jumping! Jumping! Jumping!

题目链接:HDU - 1087

                               Super Jumping! Jumping! Jumping!

                         Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
                                           Total Submission(s): 54223    Accepted Submission(s): 25170

 

Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.

 

Input

Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.

 

Output

For each case, print the maximum according to rules, and one line one case.

 

Sample Input

3 1 3 2

4 1 2 3 4

4 3 3 2 1

0

Sample Output

4

10

3

题意描述:

寻找出最大递增字符串,然后算出它们的和,输出即可

其实这道题是个DP题,我本来用的是暴力,没过,所以就用DP,循环比较当前值和之前的值,更新DP数组即可,DP数组里面就是最优解。

代码篇:

#include <stdlib.h>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <cstdio>
#define ll long long
using namespace std;
int main()
{
    ll n, dp[1005], a[1005];
    while(~scanf("%lld",&n))
    {
        memset(dp, 0, sizeof(dp)); ///每次使用都要清空
        ll sum = 0;
        if(n == 0)
            break;
        for(int i = 0; i < n; i++)
            scanf("%lld",&a[i]);
        dp[0] = a[0];
        for(int i = 1; i < n; i++)
        {
            for(int j = 0; j < i; j++)
            {
                if(a[i] > a[j])
                    dp[i] = max(dp[i],dp[j] + a[i]); ///更新DP数组
            }
            dp[i] = max(dp[i],a[i]); ///第一个更新
        }
        for(int i = 0; i < n; i ++)
            sum = max(dp[i], sum);
        cout << sum << endl;
    }
    return 0;
}

 

OVER!

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值